#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdbool.h>
#include "structures.h"

void global(void);
/* Menus */
void menu(VilleIUT *tiut[], int *nbIUT);
void menuUtilisateur(VilleIUT *tiut[], int *nbIUT);
void menuAdministrateur(VilleIUT *tiut[], int *nbIUT);

/* Partie 1 */
ListeDept listenouv(void);
ListeDept insererEnTete(ListeDept l, char departement[], int nbP, char resp[]);
ListeDept inserer(ListeDept l, char departement[], int nbP, char resp[]);
void afficher(ListeDept l);
bool vide(ListeDept l);
void afficherDept(ListeDept l);
int rechercheDept(ListeDept l, char departement[], bool *trouve);
ListeDept supprimerEnTete(ListeDept l);
ListeDept supprimer(ListeDept l, char departement[]);
int longueur(ListeDept l);

int getNbP(ListeDept l, int pos);
void setNbP(ListeDept l, int pos, int valeur);
char *getResp(ListeDept l, int pos);
void setResp(ListeDept l, int pos, char valeur[]);
char *getDept(ListeDept l, int pos);
void setResp(ListeDept l, int pos, char valeur[]);

/* Fichier */
int chargementVillesIUT(VilleIUT *tiut[]);
int rechercheVille(VilleIUT *tiut[], int nbIUT, char val[], bool *trouve);
void sauvegardeVillesIUT(VilleIUT *tiut[], int nbIUT);

/* Utilisateur */
void affichageVillesIUT(VilleIUT *tiut[], int nbIUT);
void affichageDeptIUT(VilleIUT *tiut[], int nbIUT);
void affichageNbP(VilleIUT *tiut[], int nbIUT);
void affichageDeptParticulier(VilleIUT *tiut[], int nbIUT);

/* Administrateur */
void modificationNbPDept(VilleIUT *tiut[], int nbIUT);
void creationDept(VilleIUT *tiut[], int nbIUT);
int suppressionDept(VilleIUT *tiut[], int nbIUT);
void modificationRespDept(VilleIUT *tiut[], int nbIUT);

// Partie 3

// Departement lireDpt(FILE *flot, ListeDepartement dpt);
// void afficheDept(Departement dpt);
// Admission lireCandidat(FILE *flot, ListeAdmission la);
// void afficherCandidat(Admission candidat);
int chargerCandidats(MaillonEtudiant *tetud[]);
// void sauvegarderCandidats(ListeAdmission listeCandidats, char dptResAdmi[30]);
// void afficherCandidatsAdmis(ListeAdmission listeCandidats);
// void afficherCandidatsNonAdmis(ListeAdmission listeCandidats);
// void afficherCandidatsAttente(ListeAdmission listeCandidats);
// void afficherCandidatsDpt(ListeAdmission listeCandidats);
// ListeAdmission MoyenneCandidats(ListeAdmission listeCandidats);

// Liste Choix
ListeChoix listenouvChoix(void);
ListeChoix insererEnTeteChoix(ListeChoix lc, Choix choix);
ListeChoix insererChoix(ListeChoix lc, Choix choix);
ListeChoix supprimerEnTeteChoix(ListeChoix lc);
ListeChoix supprimerChoix(ListeChoix lc, Choix choix);
bool rechercheChoix(ListeChoix lc, Choix choix);
Choix TeteChoix(ListeChoix lc);
bool videChoix(ListeChoix lc);
void afficherChoix(ListeChoix lc);
int longueurChoix(ListeChoix lc);
void afficherCandidatsChoix(Choix choix);

/*
Departement lireDpt(FILE *flot);
void afficherDpt(Departement dpt);
Admission lireCandidat(FILE *flot);
void afficherCandidat(Admission candidat);
ListeAdmission chargerCandidats(char *ficAdmission, char dptResAdmi[30]);
void sauvegarderCandidats(ListeAdmission lAdmission, char dptResAdmi[30]);
void afficherCandidatsAdmis(ListeAdmission listeCandidats);
void afficherCandidatsNonAdmis(ListeAdmission listeCandidats);
void afficherCandidatsAttente(ListeAdmission listeCandidats);
void afficherCandidatsDpt(ListeAdmission listeCandidats);
ListeAdmission MoyenneCandidats(ListeAdmission listeCandidats);
int modifNoteMinAdmis();
int modifNbAdmisMax();

// Authentification

int ConnexionUtilisateur(char *login, char *mdp);
ListeUtilisateurs chargerUtilisateurs(char *ficUtilisateurs, ListeUtilisateurs Utilisateurs);
Utilisateur lireUtilisateur(FILE *flot);
void afficherUtilisateur(Utilisateur utilisateur);
void afficherUtilisateurs(ListeUtilisateurs listeUtilisateurs);
ListeUtilisateurs insererUtilisateur(ListeUtilisateurs listeUtilisateurs, Utilisateur utilisateur);
ListeUtilisateurs supprimerUtilisateur(ListeUtilisateurs listeUtilisateurs, char *nomUtilisateur);
int videUtilisateurs(ListeUtilisateurs listeUtilisateurs);
void sauveUtilisateurs(char *ficUtilisateurs, ListeUtilisateurs listeUtilisateurs);
int rechercherUtilisateur(ListeUtilisateurs listeUtilisateurs, char *nomUtilisateur);
int supprimerUtilisateur(ListeUtilisateurs listeUtilisateurs, char *nomUtilisateur);
int menuUtilisateur(ListeUtilisateurs listeUtilisateurs);
void global(void);*/